;-----------------------------------------------------------------------------
; *** 160 x 144 hicolor library ***
; Compiled with GBDK v2.1.5

        .include "../../lib/global.s"

        .globl  .display_off
        .globl  .int_0x40
        .globl  .int_0x48
        .globl  .jpad

        .area   _BSS

.StackStorage:
        .ds     2

        .area   _CODE

;-----------------------------------------------------------------------------
; Retrieves the current speed
;-----------------------------------------------------------------------------

_CurrentSpeed::
        ldh     a,(.KEY1)
	rlca			;bit7->bit0
	and	a, #1
	ld	e, a		;return
        ret

;-----------------------------------------------------------------------------
; Switches between normal and double speed
;-----------------------------------------------------------------------------

_SwitchSpeed::
	di

        ld      hl, #0xFF00+.IE
	ld	a, (hl)		;save EI
        push    af
        xor     a, a
	ld	(hl), a		;clear EI
        ldh     (.IF), a  ;clear IF

	ld	a, #0x30
        ldh     (.P1), a ;P1

	ld	a, #1
        ldh     (.KEY1), a

        stop

	nop

	pop	af
	ld	(hl), a		;restore EI

	ei
        ret

;-----------------------------------------------------------------------------


_remove_irqs::
  ld	hl, #.int_0x40
  xor	a, a
  ld	(hl+), a
  ld	(hl+), a
  ld	(hl+), a
  ld	(hl), a
  ld	hl, #.int_0x48
  ld	(hl+), a
  ld	(hl+), a
  ld	(hl+), a
  ld	(hl), a
  ret

;----------------------------------------------------------------------------;

_wait_vbl_done2::
  ldh	a, (.ly)
  cp	a, #144
  jr	nz, _wait_vbl_done2
  ret

;----------------------------------------------------------------------------;

; void DisplayHiClr (char BANK, char KEYMASK);
;; KEYMASK for continue:
;;   0x80 - Start   0x08 - Down
;;   0x40 - Select  0x04 - Up
;;   0x20 - B       0x02 - Left
;;   0x10 - A       0x01 - Right

_DisplayHiclr::
  push bc
  push de
  push hl
  lda  hl,8(sp)
  ld   a,(hl+)
  ld   b,(hl)
  call _DspHiclr
  pop  hl
  pop  de
  pop  bc
  ret


_DspHiclr:

  ld    (0x2000),a                       ; Switch to relevant bank

  call  .display_off

  ldh   a,(.LCDC)
  push  af              ; Save LCDC settings

  push  bc              ; save KEYMASK

	xor		a					; Switch to character bank 0
  ldh   (.VBK),a

  ld    de,#0x8800      ; Address for BG characters
  ld    bc,#16 * 256    ; Transfer 256 characters

  ld    a,(0x4000)     ; Get address of where characters stored
	ld		l,a
  ld    a,(0x4001)

	ld		h,a
  call  _TransferCharData  ; Transfer characters

  ld    a,#1         ; Switch to alternate character bank
  ldh   (.VBK),a

  ld    de,#0x8800
  ld    bc,#16 * 104    ; Transfer 104 characters

  call  _TransferCharData

  ld    hl,#0x9800      ; Screen Address (attributes)
  ld    a,(0x4002)
	ld		c,a
  ld    a,(0x4003)
	ld		b,a					; BC = Attribute memory

  call  _WriteScreen     ; Transfer character attributesWriteScreen:

	xor		a
  ldh   (.VBK),a

  ld    hl,#0x9800
  ld    a,(0x4004)
	ld		c,a
  ld    a,(0x4005)
	ld		b,a					; BC = Map memory

  call  _WriteScreen

; *** Set all palettes black ***

  ld    a,#0x80       ;
  ld    (0xff00+.BCPS),a      ;setup palette write.

  ld    b,#32*2
  xor   a
_ClrPals:
  ldh   (.BCPD),a
  dec   b
  jr    nz,_ClrPals

; *** Turn on screen ***

  ld    a,#0x83     ; LCDCF_ON | LCDCF_OBJON | LCDCF_BGON | LCDCF_WIN9800
  ldh   (.LCDC),a

_OnLoop:
  ldh   a,(.LY)
  cp    #144
  jr    c,_OnLoop

; *** Display hicolor photo until button pressed ***

  pop   bc

_wait2:
  call  .jpad
  and   b
  or    a                       ; Correct button(s) pressed?
  jp    nz,_exit                ; yes, exit

  di

  ld    (.StackStorage),sp      ;store SP.

  ld    a,#1
  ldh   (.VBK),a


  ld    hl,#0x4006
  ld    a,(hl+)
  ld    h,(hl)
  ld    l,a     ; hl = palette data addr
  ld    sp,hl       ;

  ld    a,#0x80       ;
  ld    hl,#0xff00+.BCPS      ;setup palette write.
  ld    (hl),a        ;


  ld    hl,#0xff00+.LY
	xor		a

_wait:
  cp    (HL)
	jr		nz,_wait

_palloop:

	pop		de            		;get 2 palette values.

  ld    l,#.STAT           ;point HL to STAT.

_waitstat2:
  bit   1,(hl)        ;wait for HBlank.
	jr		nz,_waitstat2 		;

  ld    l,#.BCPD

  ld    (hl),e            ;
  ld    (hl),d            ;write 2 palette values.

	pop		de
  ld    (hl),e        ;
  ld    (hl),d

	pop		de            		;get 2 palette values.
  ld    (hl),e            ;
  ld    (hl),d            ;write 2 palette values.

	pop		de					;
  ld    (hl),e        ;
  ld    (hl),d

	pop		de            		;get 2 palette values.
  ld    (hl),e            ;
  ld    (hl),d            ;write 2 palette values.

	pop		de
  ld    (hl),e        ;
  ld    (hl),d

	pop		de            		;get 2 palette values.
  ld    (hl),e            ;
  ld    (hl),d            ;write 2 palette values.

	pop		de
  ld    (hl),e        ;
  ld    (hl),d

	pop		de            		;get 2 palette values.
  ld    (hl),e            ;
  ld    (hl),d            ;write 2 palette values.

	pop		de
  ld    (hl),e        ;
  ld    (hl),d

	pop		de            		;get 2 palette values.
  ld    (hl),e            ;
  ld    (hl),d            ;write 2 palette values.

	pop		de
  ld    (hl),e        ;
  ld    (hl),d

	pop		de            		;get 2 palette values.
  ld    (hl),e            ;
  ld    (hl),d            ;write 2 palette values.

	pop		de
  ld    (hl),e        ;
  ld    (hl),d

	pop		de            		;get 2 palette values.
  ld    (hl),e            ;
  ld    (hl),d            ;write 2 palette values.

	pop		de
  ld    (hl),e        ;
  ld    (hl),d


  ldh   a,(.LY)           ;
  cp    #142         ;test for bottom of image.
	jr		nz,_palloop			;

  ld    hl,#.StackStorage
  ld    a,(hl+)           ;
  ld    h,(hl)        ;restore SP.
	ld		l,a					;
	ld		sp,hl

  ei

  jp      _wait2

_exit:
  pop   af
  ldh   (.LCDC),a     ; Restore LCDC settings
  ret

; ********************************************************
; Transfers CharData to VRAM
; Load DE with the VRAM address
; Load HL with address of the char data
; Load BC with the bytes to transfer
; ********************************************************

_TransferCharData:
	push	af

_CharLoop:

  ld    a,(hl+)            ; Load char data
  ld    (de), a
	inc		de                 ; increment memory location
	dec		bc                 ; decrement counter
	ld		a, b               ; transfer upper byte of counter to a
	or		c                  ; or with c. Check to see if both are zero
  jr    nz,_CharLoop       ; If not zero repeat

	pop  	af

	ret


_WriteScreen:
  ld    a,#18

_yloop:
  ld    e,#20
	push	af

_xloop:
  ld    a,(bc)
	inc		bc
  ld    (hl+),a
	dec		e
  jr    nz,_xloop

  ld    de,#12
	add		hl,de
	pop		af
	dec		a
  jr    nz,_yloop
	ret

